/*
To do:

T = needs testing
X = done
- = cancelled

[X] remove delay on resethud event?
[X] ftTaskUpdateAmpksAndMoneyHUD instead of ftMessageMoneySend in zpnm_user_get_ammo_packs
[T] fix crash related to sending the money message to a disconnected player
[T] ignore bots
v0.0.7
[ ] use new item selected post native and remove delay?
[ ] 
*/

// Modules
#include <amxmodx>

// Plug-in APIs
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>

new g_iBsBot, g_iAmmoPacks[33], g_iIDMessageMoney;

public plugin_init()
{
	register_plugin("[ZPNM] Display ampks as money", "0.0.7", "D i 5 7 i n c T, meTaLiCroSS")
	
	register_event("ResetHUD", "fwEventResetHUD", "b")
	
	g_iIDMessageMoney = get_user_msgid("Money");
}

public plugin_cfg()
	set_task(0.1, "ftTaskChangeCvar")

public ftTaskChangeCvar()
	set_cvar_num("zp_remove_money", 2)

public client_connect(iID)
	bitsum_del(g_iBsBot, iID)

public client_authorized(iID)
{
	if (is_user_bot(iID))
		bitsum_add(g_iBsBot, iID)
}

public fwEventResetHUD(const iID)
{
	remove_task(iID)
	ftMessageMoneySend(iID, g_iAmmoPacks[iID], false)
}

public ftTaskUpdateAmpksAndMoneyHUD(const szUpdateAndFlash[], const iID)
{
	if (szUpdateAndFlash[0])
	{
		new iAmmoPacksNew;
		
		if ((iAmmoPacksNew = zp_get_user_ammo_packs(iID)) == g_iAmmoPacks[iID])
			return;
		
		g_iAmmoPacks[iID] = iAmmoPacksNew;
	}
	
	ftMessageMoneySend(iID, g_iAmmoPacks[iID], szUpdateAndFlash[0])
}

ftMessageMoneySend(const iID, const iAmount, const bFlash)
{
	if (!is_user_connected(iID) || bitsum_get(g_iBsBot, iID))
		return;
	
	message_begin(MSG_ONE_UNRELIABLE, g_iIDMessageMoney, _, iID)
	write_long(iAmount)
	write_byte(bFlash)
	message_end()
}

public zpnm_user_get_ammo_packs(iID, iAmount, iSource)
{
/*	if (iSource == AMMO_MAIN)
		return;
	*/
	remove_task(iID)
	ftTaskUpdateAmpksAndMoneyHUD({ 1 }, iID)
}

public zp_extra_item_selected(iID, iItemID, bIgnoreCost, iCost)
{
	if (bIgnoreCost || !iCost)
		return;
	
	remove_task(iID)
	set_task(0.1, "ftTaskUpdateAmpksAndMoneyHUD", iID, { 1 }, 1)
}
