/*
To do:

T = needs testing
X = done
- = cancelled

[X] remove hamsandwich and use fakemeta only
v0.0.7
[X] fix && typo instead of & and optimize
[T] AMXX 183 disconnect support
v0.0.9
[ ] check if we need to make sure we have a valid player id for fwFmCmdStartPre
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>

// Plug-in APIs
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>

new g_iBsFrozen;

public plugin_init()
{
	register_plugin("[ZPNM] Freeze block attack", "0.0.9", "D i 5 7 i n c T")
	
	register_forward(FM_CmdStart, "fwFmCmdStartPre")
}

#if AMXX_VERSION_NUM <= 182
public client_disconnect(iID)
#else
public client_disconnected(iID)
#endif
	bitsum_del(g_iBsFrozen, iID);

public zpnm_user_spawn_post(iID)
	bitsum_del(g_iBsFrozen, iID);

public zpnm_user_frozen(iID)
	bitsum_add(g_iBsFrozen, iID);

public zp_user_unfrozen(iID)
	bitsum_del(g_iBsFrozen, iID);

public fwFmCmdStartPre(const iID, const iIDCmd)
{
	if (!bitsum_get(g_iBsFrozen, iID))
		return;
	
	new iBsButtons = get_uc(iIDCmd, UC_Buttons);
	
	if (!(iBsButtons & (IN_ATTACK | IN_ATTACK2)))
		return;
	
	iBsButtons &= ~(IN_ATTACK | IN_ATTACK2);
	
	set_uc(iIDCmd, UC_Buttons, iBsButtons)
}
