#include <amxmodx>
#include <bitsums>
#include <fakemeta>
#include <hamsandwich>
#include <zombieplaguenightmare>

new g_flagFrozen;

public plugin_init()
{
	register_plugin("[ZPNM] Freeze block attack", "0.0.6", "D i 5 7 i n c T")
	
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_flashbang", "HamOnAttackPre")
	RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_flashbang", "HamOnAttackPre")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_hegrenade", "HamOnAttackPre")
	RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_hegrenade", "HamOnAttackPre")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_knife", "HamOnAttackPre")
	RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_knife", "HamOnAttackPre")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_smokegrenade", "HamOnAttackPre")
	RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_smokegrenade", "HamOnAttackPre")
}

public client_disconnect(iID)
	bitsum_del(g_flagFrozen, iID);

public zpnm_user_spawn_post(iID)
	bitsum_del(g_flagFrozen, iID);

public zpnm_user_frozen(iID)
	bitsum_add(g_flagFrozen, iID);

public zp_user_unfrozen(iID)
	bitsum_del(g_flagFrozen, iID);

public HamOnAttackPre(iEnt)
{
	if (pev_valid(iEnt) != 2)
		return HAM_IGNORED;
	
	new iPlayerID = get_pdata_cbase(iEnt, 41, 4);
	
	static iMaxPlayers;
	
	if (!iMaxPlayers)
		iMaxPlayers = get_maxplayers();
	
	if (!(1 <= iPlayerID <= iMaxPlayers) || !bitsum_get(g_flagFrozen, iPlayerID))
		return HAM_IGNORED;
	
	set_pev(iPlayerID, pev_weaponanim, 0)
	
	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, _, iPlayerID)
	write_byte(0) //sequence
	write_byte(pev(iPlayerID, pev_body))
	message_end()
	
	return HAM_SUPERCEDE;
}
