#include <amxmodx>
#include <zombieplaguenightmare>

new sound_siren[] = "zombie_plague/sirenzpde.wav"
new sound_infect[] = "zombie_plague/93zinfect3.wav"
new sound_humans[] = "zombie_plague/93win_human.wav"
new sound_zombies[] = "zombie_plague/93win_zombie.wav"

new Float:g_siren_duration = 50.0

public plugin_init()
	register_plugin("[ZPNM] Sound Effects", "1.2", "D i 5 7 i n c T")

public plugin_precache()
{
	precache_sound(sound_siren)
	precache_sound(sound_infect)
	precache_sound(sound_humans)
	precache_sound(sound_zombies)
}

public zp_round_started()
{
	if (task_exists(57))
		client_cmd(0, "stopsound")
	
	client_cmd(0, "spk %s", sound_siren)
	
	remove_task(57)
	set_task(g_siren_duration, "siren_stopped", 57)
}

public siren_stopped()
{
	// "fake" task
}

public zp_user_infected_post(id)
	client_cmd(id, "spk %s", sound_infect)

public zp_round_ended(winteam)
{
	switch (winteam)
	{
		case WIN_ZOMBIES: client_cmd(0, "spk %s", sound_zombies)
		case WIN_HUMANS: client_cmd(0, "spk %s", sound_humans)
	}
}
