#include <amxmodx>
#include <zombieplaguenightmare>

new g_escape_map, g_max_players, g_first_left

public plugin_init()
{
	register_plugin("[ZPNM] ZE: Teleport Zombies", "1.1.1", "D i 5 7 i n c T")
	
	static map_name[32]
	get_mapname(map_name, 31)
	
	if (containi(map_name, "ze_") != -1 ||
	containi(map_name, "escape") != -1 ||
	containi(map_name, "_atix") != -1)
	{
		g_escape_map = true
		g_max_players = get_maxplayers()
		register_dictionary("zpnm_escape.txt")
	}
}

public client_disconnect(id)
	if (zp_get_user_first_zombie(id) && zp_get_zombie_count() < 2)
		g_first_left = true

public zp_round_started()
{
	if (!g_escape_map)
		return;
	
	g_first_left = false
	
	static i
	
	for (i = 0; i <= g_max_players; i++)
	{
		zpnm_teleport_back(i)
		client_print(i, print_center, "%L", i, "ZPNM_TELEPORTED")
	}
}

public zp_user_last_zombie(id)
	if (g_escape_map && g_first_left)
	{
		g_first_left = false
		
		zpnm_teleport_back(id)
		client_print(0, print_center, "%L", LANG_PLAYER, "ZPNM_TELEPORTED")
	}

zpnm_teleport_back(id)
{
	if (!is_user_alive(id) || !zp_get_user_zombie(id))
		return;
	
	zpnm_teleport_user(id, 1)
}
