/*
To do:

T = needs testing
X = done
- = cancelled

[T] CZ bots support
v0.0.7
[ ] 
*/

// Modules
#include <amxmodx>
#include <cstrike>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

public plugin_init()
{
	register_plugin("[ZPNM] Respawn Pre-Mode", "0.0.7", "D i 5 7 i n c T")
	
	register_clcmd("joinclass", "clcmd_joinclass")
	
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled_Post", 1)
	RegisterHamBots(Ham_Spawn, "fw_PlayerSpawn_Post", 1)
	RegisterHamBots(Ham_Killed, "fw_PlayerKilled_Post", 1)
}

public client_disconnect(iID)
	remove_task(iID)

public clcmd_joinclass(const iID)
{
	remove_task(iID)
	set_task(0.3, "zpnm_respawn_player", iID)
}

public fw_PlayerSpawn_Post(const iID)
	remove_task(iID)

public fw_PlayerKilled_Post(const iID)
{
	remove_task(iID)
	set_task(random_float(1.0, 2.0), "zpnm_respawn_player", iID)
}

public zpnm_respawn_player(iID)
{
	if (!is_user_connected(iID) || zp_has_round_started() != 0)
		return;
	
	new CsTeams:iTeam = cs_get_user_team(iID);
	
	if (iTeam == CS_TEAM_SPECTATOR || iTeam == CS_TEAM_UNASSIGNED)
		return;
	
	zp_respawn_user(iID)
	
	if (is_user_alive(iID))
		zpnm_teleport_user(iID)
}
